## waffle 1.6.0

=== CMakeLists.txt ===
# Copyright 2012 Intel Corporation
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# - Redistributions of source code must retain the above copyright notice, this
#   list of conditions and the following disclaimer.
#
# - Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

project(waffle1 C CXX)

cmake_minimum_required(VERSION 2.8.11)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules")

# Set the default location for all build artifacts to traditionally named
# top-level directories.  CMake's default location for build artifacts varies
# per artifact and is hard-to-guess.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")

include(WaffleDefineOS)
include(WaffleFindDependencies)
include(Options.cmake)
include(WaffleDefineInternalOptions)
include(WaffleValidateOptions)
include(WaffleDefineVersion)
include(WaffleDefineCompilerFlags)
include(GNUInstallDirs)

if(waffle_build_tests)
    include(WaffleCMocka)
endif()

# Require MSVC 2013 U4
if (MSVC AND ${CMAKE_C_COMPILER_VERSION} VERSION_LESS 18.00.31101.0)
    message (FATAL_ERROR "Visual Studio 2013 Update 4 or later required")
endif ()

find_package(PkgConfig)

# ------------------------------------------------------------------------------
# Targets: check, check-func, valgrind-check, valgrind-check-func
# ------------------------------------------------------------------------------

#
# Target 'check' runs unit tests, but no functional tests.
#
add_custom_target(check)

#
# Target 'check-func' runs functional tests as well as unit tests.
#
# The unit tests are ran first (due to the depenency on 'check'). If any unit
# test fails, then no functional tests run.
#
add_custom_target(check-func
    DEPENDS check
    )

find_program(VALGRIND_EXECUTABLE valgrind)
if(VALGRIND_EXECUTABLE)
    # Runs the 'check' target under valgrind.
    add_custom_target(valgrind-check
        DEPENDS check
        )

    # Runs the 'check-func' target under valgrind.
    add_custom_target(valgrind-check-func
        DEPENDS valgrind-check check-func
        )
endif()

# ------------------------------------------------------------------------------
# Add subdirectories
# ------------------------------------------------------------------------------

if(waffle_on_mac)
    link_libraries(
        ${COCOA_FRAMEWORK}
        ${CORE_FOUNDATION_FRAMEWORK}
        )
endif()

include_directories(
    include
    include/waffle
    src
    )

add_subdirectory(third_party/threads)
include_directories(
    third_party/threads
    )
set(THREADS_LIBRARIES threads_bundled)

if(MSVC)
    add_subdirectory(third_party/getopt)
    include_directories(
        third_party/getopt
        )
    set(GETOPT_LIBRARIES getopt_bundled)
endif()

add_subdirectory(doc)
add_subdirectory(src)
add_subdirectory(include)
add_subdirectory(man)

if(waffle_build_tests)
    add_subdirectory(tests)
endif()

if(waffle_build_examples)
    add_subdirectory(examples)
endif()

# ------------------------------------------------------------------------------
# Install packaging files: waffle.pc WaffleConfigVersion.cmake, and
# WaffleConfig.cmake
# ------------------------------------------------------------------------------

configure_file(waffle.pc.in ${waffle_libname}.pc @ONLY)

install(
    FILES ${CMAKE_BINARY_DIR}/${waffle_libname}.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    COMPONENT pkgconfig
    )

set(ConfigPackageLocation "${CMAKE_INSTALL_LIBDIR}/cmake/Waffle")
include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    "${CMAKE_BINARY_DIR}/cmake/Modules/WaffleConfigVersion.cmake"
    VERSION "${waffle_version}"
    COMPATIBILITY SameMajorVersion
)

configure_package_config_file(
    cmake/Modules/WaffleConfig.cmake.in
    cmake/Modules/WaffleConfig.cmake
    INSTALL_DESTINATION "${ConfigPackageLocation}"
    PATH_VARS CMAKE_INSTALL_LIBDIR CMAKE_INSTALL_INCLUDEDIR
    NO_CHECK_REQUIRED_COMPONENTS_MACRO
)

install(
    FILES
        "${CMAKE_BINARY_DIR}/cmake/Modules/WaffleConfigVersion.cmake"
        "${CMAKE_BINARY_DIR}/cmake/Modules/WaffleConfig.cmake"
    DESTINATION "${ConfigPackageLocation}"
    COMPONENT devel
)

# ------------------------------------------------------------------------------
# Install core documentation
# ------------------------------------------------------------------------------

install(
    FILES
        "README.md"
        "LICENSE.txt"
        "HACKING.txt"
    DESTINATION "${CMAKE_INSTALL_DOCDIR}"
    COMPONENT coredocs
    )

# ------------------------------------------------------------------------------
# Install shell completion
# ------------------------------------------------------------------------------

find_package(bash-completion)
if (NOT BASH_COMPLETION_FOUND)
    # Fallback default dir
    set(BASH_COMPLETION_COMPLETIONSDIR
        "${CMAKE_INSTALL_DATADIR}/bash-completion/completions/")
endif()

install(
    FILES "shell-completion/bash/wflinfo"
    DESTINATION "${BASH_COMPLETION_COMPLETIONSDIR}"
    COMPONENT shell-completion
    )

# ------------------------------------------------------------------------------

include(WafflePrintConfigurationSummary)

set (CPACK_SET_DESTDIR ON)
set (CPACK_PACKAGE_VERSION_MAJOR ${waffle_major_version})
set (CPACK_PACKAGE_VERSION_MINOR ${waffle_minor_version})
set (CPACK_PACKAGE_VERSION_PATCH ${waffle_patch_version})

# cpack detects win64 vs win32 only when msvc is available
# reported upstream, fix (likely post cmake 3.0) pending
if (MINGW)
        if (CMAKE_SIZEOF_VOID_P EQUAL 8)
                set (CPACK_SYSTEM_NAME win64)
        endif ()
endif ()

# See http://www.vtk.org/Wiki/CMake:CPackPackageGenerators
if (WIN32)
        set (CPACK_GENERATOR "ZIP")
else ()
        set (CPACK_GENERATOR "TBZ2")
endif ()

include(CPack)

=== meson_options.txt ===
# Copyright © 2017 Dylan Baker
# Copyright © 2018 Intel Corporation
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# - Redistributions of source code must retain the above copyright notice, this
#   list of conditions and the following disclaimer.
#
# - Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# Options specifically for Non-macOS *nix systems below
option(
  'glx',
  type : 'feature',
  description : 'Build support for GLX (only for *nix)'
)
option(
  'wayland',
  type : 'feature',
  description : 'Build support for wayland (only for *nix)'
)
option(
  'x11_egl',
  type : 'feature',
  description : 'Build support for X11/EGL (only for *nix)'
)
option(
  'gbm',
  type : 'feature',
  description : 'Build support for GBM (only for mesa)'
)
option(
  'surfaceless_egl',
  type : 'feature',
  description : 'Build support for EGL_MESA_platform_surfaceless'
)

# Options specifically for ChromeOS
option(
  'nacl',
  type : 'boolean',
  value : false,
  description : 'Build support for ChromeOS NaCl'
)
option(
  'nacl_sdk_path',
  type : 'string',
  description : 'Path for NaCl SDK')
option(
  'nacl_version',
  type : 'string',
  value : 'pepper_39',
  description : 'Version of NaCL'
)

# Misc Options
option(
  'build-tests',
  type : 'boolean',
  value : false,
  description : 'Build tests'
)
option(
  'build-manpages',
  type : 'boolean',
  value : false,
  description : 'Build manpages'
)
option(
  'build-htmldocs',
  type : 'boolean',
  value : false,
  description : 'Build html documentation'
)
option(
  'build-examples',
  type : 'boolean',
  value : true,
  description : 'Build example programs'
)

=== include/CMakeLists.txt ===
configure_file(waffle/waffle_version.h.in
               ${CMAKE_CURRENT_SOURCE_DIR}/waffle/waffle_version.h
               @ONLY)

install(
    FILES
        waffle/waffle.h
        waffle/waffle_gbm.h
        waffle/waffle_glx.h
        waffle/waffle_version.h
        waffle/waffle_wayland.h
        waffle/waffle_x11_egl.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${waffle_libname}
    COMPONENT headers
    )

=== src/waffle/CMakeLists.txt ===
# ----------------------------------------------------------------------------
# Applies to all targets in this CMakeLists.
# ----------------------------------------------------------------------------

add_definitions(
    -DWAFFLE_API_VERSION=${waffle_api_version}
    -DWAFFLE_API_EXPERIMENTAL
    )

include_directories(
    android
    api
    cgl
    core
    egl
    glx
    linux
    nacl
    surfaceless_egl
    wayland
    wgl
    x11
    xegl

    ${egl_INCLUDE_DIRS}
    ${gbm_INCLUDE_DIRS}
    ${gl_INCLUDE_DIRS}
    ${GLEXT_INCLUDE_DIR}
    ${libudev_INCLUDE_DIRS}
    ${nacl_INCLUDE_DIRS}
    ${wayland-client_INCLUDE_DIRS}
    ${wayland-egl_INCLUDE_DIRS}
    ${x11-xcb_INCLUDE_DIRS}
    )

# ----------------------------------------------------------------------------
# Target: waffle (shared library)
# ----------------------------------------------------------------------------

list(APPEND waffle_libdeps
    ${THREADS_LIBRARIES}
    )

if(waffle_on_linux)
    if(waffle_has_x11)
        list(APPEND waffle_libdeps
            ${x11-xcb_LDFLAGS}
            )
    endif()
    if(waffle_has_gbm)
        list(APPEND waffle_libdeps
            ${libudev_LDFLAGS}
            )
    endif()
endif()

if(waffle_has_nacl)
    list(APPEND waffle_libdeps
        ${nacl_LDFLAGS}
        )
endif()

set(waffle_sources
    api/api_priv.c
    api/waffle_attrib_list.c
    api/waffle_config.c
    api/waffle_context.c
    api/waffle_display.c
    api/waffle_dl.c
    api/waffle_enum.c
    api/waffle_error.c
    api/waffle_gl_misc.c
    api/waffle_init.c
    api/waffle_window.c
    core/wcore_attrib_list.c
    core/wcore_config_attrs.c
    core/wcore_display.c
    core/wcore_error.c
    core/wcore_tinfo.c
    core/wcore_util.c
    )

if(waffle_on_mac)
    list(APPEND waffle_sources
        cgl/cgl_config.m
        cgl/cgl_context.m
        cgl/cgl_display.m
        cgl/cgl_dl.m
        cgl/cgl_error.m
        cgl/cgl_platform.m
        cgl/cgl_window.m
        cgl/WaffleGLView.m
        )
    list(APPEND waffle_libdeps
        ${OPENGL_gl_LIBRARY}
        )
endif()

if(waffle_has_egl)
    list(APPEND waffle_sources
        egl/wegl_config.c
        egl/wegl_context.c
        egl/wegl_display.c
        egl/wegl_platform.c
        egl/wegl_util.c
        egl/wegl_surface.c
        )
endif()

if(waffle_has_glx)
    list(APPEND waffle_sources
        glx/glx_config.c
        glx/glx_context.c
        glx/glx_display.c
        glx/glx_platform.c
        glx/glx_window.c
        )
endif()

if(waffle_on_linux)
    list(APPEND waffle_sources
        linux/linux_dl.c
        linux/linux_platform.c
        )
    list(APPEND waffle_libdeps
        dl
        pthread
        )
endif()

if(waffle_has_surfaceless_egl)
    list(APPEND waffle_sources
        surfaceless_egl/sl_display.c
        surfaceless_egl/sl_platform.c
        surfaceless_egl/sl_window.c
    )
endif()

if(waffle_has_wayland)
    list(APPEND waffle_sources
        wayland/wayland_display.c
        wayland/wayland_platform.c
        wayland/wayland_window.c
        wayland/wayland_wrapper.c
    )
endif()

if(waffle_has_x11)
    list(APPEND waffle_sources
        x11/x11_display.c
        x11/x11_window.c
        )
endif()

if(waffle_has_x11_egl)
    list(APPEND waffle_sources
        xegl/xegl_display.c
        xegl/xegl_platform.c
        xegl/xegl_window.c
    )
endif()

if(waffle_has_gbm)
    list(APPEND waffle_sources
        gbm/wgbm_config.c
        gbm/wgbm_display.c
        gbm/wgbm_platform.c
        gbm/wgbm_window.c
    )
endif()

if(waffle_on_windows)
    list(APPEND waffle_sources
        wgl/wgl_config.c
        wgl/wgl_context.c
        wgl/wgl_display.c
        wgl/wgl_dl.c
        wgl/wgl_error.c
        wgl/wgl_platform.c
        wgl/wgl_window.c
        )

    list(APPEND waffle_libdeps
        opengl32.lib
        )
endif()

if(waffle_has_nacl)
    list(APPEND waffle_sources
        nacl/nacl_config.c
        nacl/nacl_context.c
        nacl/nacl_display.c
        nacl/nacl_dl.c
        nacl/nacl_platform.c
        nacl/nacl_window.c
        )
    list(APPEND waffle_cxx_sources
        nacl/nacl_container.cpp
        )
endif()

# CMake will pass to the C compiler only C sources. CMake does not recognize the
# .m extension and ignores any such files in the source lists. To coerce CMake
# to pass .m files to the compiler, we must lie and claim that they are
# C sources.
set_source_files_properties(
    ${waffle_sources}
    PROPERTIES
    LANGUAGE C
    )

if(waffle_on_windows)
    configure_file(
        waffle.def.in
        ${CMAKE_CURRENT_SOURCE_DIR}/${waffle_libname}.def
        @ONLY
        )

    list(APPEND waffle_sources
        ${waffle_libname}.def
        )
endif()

include_directories(
    ${GLX_INLCLUDE_DIRS}
    ${X11_INCLUDE_DIRS}
    ${X11-XCB_INCLUDE_DIRS}
    ${XCB_INCLUDE_DIRS}
    )

add_library(${waffle_libname} SHARED ${waffle_sources} ${waffle_cxx_sources})

# Debian's packaging system emits warnings if wflinfo directly links to any
# library that it doesn't directly use. Silence the warnings by annotating
# libwaffle's library dependencies as private, which prevents wflinfo from
# linking to them.
if(CMAKE_VERSION VERSION_LESS "2.8.12")
    # On older CMake, we must rely on hacking the LINK_INTERFACE_LIBRARIES
    # property.
    if(NOT waffle_on_mac)
        set_target_properties(${waffle_libname}
            PROPERTIES
            LINK_INTERFACE_LIBRARIES ""
            )
    endif()
else()
    # CMake 2.8.12 introduced the PRIVATE keyword to target_link_libraries().
    # All libraries listed after PRIVATE get annotated as such.
    list(INSERT waffle_libdeps 0 PRIVATE)
endif()

target_link_libraries(${waffle_libname} ${waffle_libdeps})

set_target_properties(${waffle_libname}
    PROPERTIES
    SOVERSION ${waffle_soversion}
    VERSION ${waffle_soversion}.${waffle_minor_version}.${waffle_patch_version}
    )

if(waffle_on_windows)
    set_target_properties(${waffle_libname}
        PROPERTIES
        PREFIX ""
    )
endif()

install(
    TARGETS ${waffle_libname}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT libraries
    )

# ----------------------------------------------------------------------------
# Target: waffle_static
# ----------------------------------------------------------------------------

# The unittest executable needs access to waffle's internal symbols. Yet, the
# sources in libwaffle.so are compiled with -fvisibility=hidden.
# One solution is to additionally build a static libwaffle and let the
# unittest executable link to that. Visibility options do not apply to static
# libraries; that is, all symbols are public.

add_library(waffle_static
    STATIC
    EXCLUDE_FROM_ALL
    ${waffle_sources}
    )

target_link_libraries(waffle_static ${waffle_libdeps})

set_target_properties(waffle_static
    PROPERTIES
    OUTPUT_NAME "waffle-static-${waffle_major_version}"
    )

# ----------------------------------------------------------------------------
# Unit Tests
# ----------------------------------------------------------------------------

function(add_unittest unittest_name)
    if(NOT waffle_build_tests)
        return()
    endif()

    add_executable(${unittest_name} ${ARGN})
    set_target_properties(${unittest_name}
        PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/tests"
    )
    target_link_libraries(${unittest_name}
        cmocka
        waffle_static
    )
    add_custom_target(${unittest_name}_run
        COMMAND "${unittest_name}"
    )
    add_dependencies(check ${unittest_name}_run)

    if(VALGRIND_EXECUTABLE)
        add_custom_target(valgrind_${unittest_name}_run
            DEPENDS ${unittest_name}
            COMMAND ${VALGRIND_EXECUTABLE} $<TARGET_FILE:${unittest_name}>
        )
        add_dependencies(valgrind-check valgrind_${unittest_name}_run)
    endif()
endfunction()

add_unittest(wcore_attrib_list_unittest
    core/wcore_attrib_list_unittest.c
)
add_unittest(wcore_config_attrs_unittest
    core/wcore_config_attrs_unittest.c
)
add_unittest(wcore_error_unittest
    core/wcore_error_unittest.c
)

=== third_party/cmocka/example/chef_wrap/CMakeLists.txt ===
project(cmocka-wrap-examples C)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMOCKA_PUBLIC_INCLUDE_DIRS}
)

add_executable(waiter_test_wrap waiter_test_wrap.c chef.c)
target_link_libraries(waiter_test_wrap ${CMOCKA_SHARED_LIBRARY})

add_test(waiter_test_wrap ${CMAKE_CURRENT_BINARY_DIR}/waiter_test_wrap)

set_target_properties(waiter_test_wrap
        PROPERTIES
        LINK_FLAGS  "-Wl,--wrap=chef_cook"
)
if (WIN32)
    set_tests_properties(waiter_test_wrap PROPERTIES ENVIRONMENT "PATH=${DLL_PATH_ENV}")
endif (WIN32)

=== debian/changelog ===
waffle (1.6.0-3) unstable; urgency=medium

  * d/control: build-dep libx11-dev => libx11-xcb-dev (Closes #948779)
  * d/gbp.conf: Add git-buildpackage config file

 -- Jordan Justen <jordan.l.justen@intel.com>  Thu, 23 Jan 2020 16:59:58 -0800

waffle (1.6.0-2) unstable; urgency=medium

  * Start new changelog
  * d/rules: Enable surfaceless_egl
  * debian: Increase debhelper to 12
  * d/control: Increase Standards-Version to 4.4.0

 -- Jordan Justen <jordan.l.justen@intel.com>  Fri, 19 Jul 2019 01:50:12 -0700

waffle (1.6.0-1) experimental; urgency=medium

  * New upstream release.
    - wflinfo can output JSON [Dylan Baker]
    - EGL/GBM: Add support for modifiers [Jason Ekstrand]
  * d/control: Move Vcs-* to salsa.debian.org/xorg-team
  * d/watch: Update watch file for upstream freedesktop.org move
  * d/control: Update Standards-Version to 4.3.0
  * d/copyright: Use debian doc https url
  * d/compat: Update from 9 to 11
  * d/compat: Update debhelper from 9 to 11
  * debian: Add pgp verification with Chad Versace's key
  * debian: Add Dylan Baker's gpg key for 1.6.0 release
  * d/watch: Update version to 4

 -- Jordan Justen <jordan.l.justen@intel.com>  Fri, 07 Jun 2019 14:43:49 -0700

=== debian/control ===
Source: waffle
Priority: optional
Section: libs
Maintainer: Jordan Justen <jordan.l.justen@intel.com>
Build-Depends: binutils (>> 2.18),
               cmake,
               debhelper (>= 12),
               docbook-xsl,
               libegl1-mesa-dev | libegl-dev,
               libgl1-mesa-dev | libgl-dev,
               libglu1-mesa-dev | libglu-dev,
               libgbm-dev,
               libudev-dev,
               libwayland-dev,
               libx11-xcb-dev,
               pkg-config,
               xsltproc
Standards-Version: 4.4.0
Homepage: http://www.waffle-gl.org
Vcs-Git: https://salsa.debian.org/xorg-team/lib/waffle.git
Vcs-Browser: https://salsa.debian.org/xorg-team/lib/waffle

Package: libwaffle-1-0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Pre-Depends}, ${misc:Depends}
Description: Waffle library (binaries)
 A library for selecting an OpenGL API and window system at runtime

Package: libwaffle-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libwaffle-1-0 (= ${binary:Version}), ${misc:Depends}
Suggests: libwaffle-doc
Description: Waffle library (development files)
 A library for selecting an OpenGL API and window system at runtime
 .
 This package provides the development environment for compiling
 programs against the waffle library.

Package: libwaffle-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Waffle library (documentation)
 A library for selecting an OpenGL API and window system at runtime
 .
 This package provides the documentation files for the waffle
 library.

Package: waffle-utils
Architecture: any
Section: utils
Depends: libwaffle-1-0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Waffle library (utilities)
 A library for selecting an OpenGL API and window system at runtime
 .
 This package contains waffle utilities:
  * wflinfo: Creates an OpenGL context and prints information about
             the created context.

=== debian/rules ===
#!/usr/bin/make -f
# Copyright (c) 2013 Intel Corporation

DEB_DESTDIR := $(CURDIR)/debian/tmp

%:
	dh $@ --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BINARY_DIR=$(CURDIR)/debian/tmp \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
		-DCMAKE_BUILD_TYPE=Release \
		-Dwaffle_has_gbm=1 \
		-Dwaffle_has_glx=1 \
		-Dwaffle_has_surfaceless_egl=1 \
		-Dwaffle_has_x11_egl=1 \
		-Dwaffle_has_wayland=1 \
		-Dwaffle_build_manpages=1 \
		-Dwaffle_build_htmldocs=0 \
		-Dwaffle_build_examples=0

=== debian/watch ===
version=4
opts="pgpmode=auto" \
https://mesa.pages.freedesktop.org/waffle/releases.html \
.*/waffle-(\d\S*)\.tar\.xz

## waffle 1.6.1

=== debian/changelog ===
waffle (1.6.1-1) unstable; urgency=medium

  * New upstream release
  * d/upstream/signing-key.asc: Add Emil Velikov's gpg key for 1.6.1 release
  * d/control: Add bash-completion build dependency
  * d/waffle-utils.install: Install bash-completions
  * d/patches: Fix some spelling errors caught by lintian
  * d/rules: Fix lintian hardening-no-bindnow
  * d/libwaffle-1-0.symbols: Add symbol file for lintian no-symbols-control-file
  * d/control: Split out Pre-Depends for libwaffle-1-0
  * d/control: Fix extended-description-is-probably-too-short for libwaffle-1-0
  * d/patches: Patch docbookx.dtd url to local file path
  * d/control: Depend on docbook-xml for 4.2/docbookx.dtd
  * d/patches: Add refpurpose on waffle_enum page for lintian manpage-has-bad-whatis-entry

 -- Jordan Justen <jordan.l.justen@intel.com>  Sun, 12 Apr 2020 22:54:23 -0700

waffle (1.6.0-4) unstable; urgency=medium

  * d/control: Drop binutils from Build-Depends. Closes: #877605
  * d/control: Update Standards-Version to 4.5.0
  * d/control: Use debhelper-compat (= 12)

 -- Jordan Justen <jordan.l.justen@intel.com>  Thu, 12 Mar 2020 15:13:57 -0700

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,11 @@
 Priority: optional
 Section: libs
 Maintainer: Jordan Justen <jordan.l.justen@intel.com>
-Build-Depends: binutils (>> 2.18),
+Build-Depends: bash-completion,
                cmake,
-               debhelper (>= 12),
+               debhelper-compat (= 12),
+               dh-exec,
+               docbook-xml,
                docbook-xsl,
                libegl1-mesa-dev | libegl-dev,
                libgl1-mesa-dev | libgl-dev,
@@ -15,7 +17,7 @@
                libx11-xcb-dev,
                pkg-config,
                xsltproc
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Homepage: http://www.waffle-gl.org
 Vcs-Git: https://salsa.debian.org/xorg-team/lib/waffle.git
 Vcs-Browser: https://salsa.debian.org/xorg-team/lib/waffle
@@ -23,9 +25,12 @@
 Package: libwaffle-1-0
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Pre-Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
 Description: Waffle library (binaries)
  A library for selecting an OpenGL API and window system at runtime
+ .
+ This package contains the waffle runtime shared library.
 
 Package: libwaffle-dev
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,8 @@
 # Copyright (c) 2013 Intel Corporation
 
 DEB_DESTDIR := $(CURDIR)/debian/tmp
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
 	dh $@ --buildsystem cmake

## waffle 1.6.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -195,7 +195,7 @@
 
 install(
     FILES "shell-completion/bash/wflinfo"
-    DESTINATION "${BASH_COMPLETION_COMPLETIONSDIR}"
+    DESTINATION "${CMAKE_INSTALL_PREFIX}/${BASH_COMPLETION_COMPLETIONSDIR}"
     COMPONENT shell-completion
     )

=== tests/functional/CMakeLists.txt ===
set(gl_basic_test_sources
    gl_basic_test.c
    )

if(waffle_on_mac)
    list(APPEND gl_basic_test_sources
        gl_basic_cocoa.m
        )
endif()

if(NOT MSVC)
    set_source_files_properties(
        ${gl_basic_test_sources}
        PROPERTIES
            COMPILE_FLAGS "-Wno-initializer-overrides"
    )
endif()

# CMake will pass to the C compiler only C sources. CMake does not recognize the
# .m extension and ignores any such files in the source lists. To coerce CMake
# to pass .m files to the compiler, we must lie and claim that they are
# C sources.
set_source_files_properties(
    ${gl_basic_test_sources}
    PROPERTIES LANGUAGE C
    )

add_executable(gl_basic_test
    ${gl_basic_test_sources}
    )

target_link_libraries(gl_basic_test
    ${waffle_libname}
    cmocka
    ${GETOPT_LIBRARIES}
    )

# ----------------------------------------------------------------------------
# Per platform functionality tests
# ----------------------------------------------------------------------------

function(add_functest platform_name)
    add_custom_target(gl_basic_test_${platform_name}_run
        COMMAND gl_basic_test --platform ${platform_name}
    )
    add_dependencies(check-func gl_basic_test_${platform_name}_run)

    if(VALGRIND_EXECUTABLE)
        add_custom_target(valgrind_gl_basic_test_${platform_name}_run
            DEPENDS gl_basic_test
            COMMAND ${VALGRIND_EXECUTABLE} $<TARGET_FILE:gl_basic_test> --platform ${platform_name}
        )

        add_dependencies(valgrind-check-func valgrind_gl_basic_test_${platform_name}_run)
    endif()
endfunction()

if(waffle_on_mac)
    add_functest(cgl)
endif()

if(waffle_on_linux)
    if(waffle_has_glx)
        add_functest(glx)
    endif()

    if(waffle_has_wayland)
        add_functest(wayland)
    endif()

    if(waffle_has_x11_egl)
        add_functest(x11_egl)
    endif()

#    if(waffle_has_gbm)
#        add_functest(gbm)
#    endif()
endif()

if(waffle_on_windows)
    add_functest(wgl)
endif()

=== debian/changelog ===
waffle (1.6.3-1) unstable; urgency=medium

  * New upstream release
  * debian: Convert from cmake to meson build
  * d/patches: Rebase on v1.6.3
  * d/patches: Cherry-pick patch from upstream to produce cmake files
  * d/waffle-utils.install: Upstream now installs bash-completion properly
  * d/patches: Add patch to hide symbols of threads helper lib

 -- Jordan Justen <jljusten@debian.org>  Thu, 25 Feb 2021 00:51:00 -0800

waffle (1.6.1-3) unstable; urgency=medium

  * d/rules: Override dh_missing for arch-indep builds. Closes: #972970

 -- Jordan Justen <jljusten@debian.org>  Mon, 02 Nov 2020 01:51:32 -0800

waffle (1.6.1-2) unstable; urgency=medium

  * debian/control: Update Jordan's email address
  * debian/not-installed: Add for debhelper-compat 13
  * debian/control: Update to debhelper-compat 13

 -- Jordan Justen <jljusten@debian.org>  Mon, 26 Oct 2020 03:31:30 -0700

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: waffle
 Priority: optional
 Section: libs
-Maintainer: Jordan Justen <jordan.l.justen@intel.com>
+Maintainer: Jordan Justen <jljusten@debian.org>
 Build-Depends: bash-completion,
                cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                dh-exec,
                docbook-xml,
                docbook-xsl,
@@ -15,7 +15,10 @@
                libudev-dev,
                libwayland-dev,
                libx11-xcb-dev,
+               meson,
                pkg-config,
+               python3,
+               python3-setuptools,
                xsltproc
 Standards-Version: 4.5.0
 Homepage: http://www.waffle-gl.org

=== debian/rules ===
#!/usr/bin/make -f
# Copyright (c) 2013 Intel Corporation

DEB_DESTDIR := $(CURDIR)/debian/tmp

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=meson --builddirectory=build/

confflags += \
	-D gbm=enabled \
	-D glx=enabled \
	-D surfaceless_egl=enabled \
	-D xenabledenabled_egl=enabled \
	-D wayland=enabled \
	-D build-manpages=true \
	-D build-htmldocs=false \
	-D build-examples=false

override_dh_auto_configure:
	$(buildflags) dh_auto_configure -- \
		$(confflags)

override_dh_missing-indep:
	dh_missing --list-missing

## waffle 1.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 
 project(waffle1 C CXX)
 
-cmake_minimum_required(VERSION 2.8.11)
+cmake_minimum_required(VERSION 2.8.12)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules")
 
@@ -101,7 +101,7 @@
 
 include_directories(
     include
-    include/waffle
+    include/waffle-1
     src
     )

=== doc/CMakeLists.txt ===
install(
    DIRECTORY "${CMAKE_SOURCE_DIR}/doc/release-notes"
    DESTINATION "${CMAKE_INSTALL_DOCDIR}"
    COMPONENT releasenotes
    )

=== examples/CMakeLists.txt ===
install(
    FILES
        Makefile.example
        gl_basic.c
        simple-x11-egl.c
    DESTINATION "${CMAKE_INSTALL_DOCDIR}/examples"
    COMPONENT examples
    )

# ----------------------------------------------------------------------------
# Target: simple-x11-egl (executable)
# ----------------------------------------------------------------------------

if(waffle_on_linux AND waffle_has_x11_egl)
    add_executable(simple-x11-egl simple-x11-egl.c)
    target_link_libraries(simple-x11-egl ${waffle_libname})
endif()

# ----------------------------------------------------------------------------
# Target: gl_basic_nacl (executable + JSON manifest file)
# ----------------------------------------------------------------------------
if (waffle_has_nacl)
    add_executable(gl_basic_nacl.nexe gl_basic.c)
    include_directories(${nacl_INCLUDE_DIRS})

    # Set path where to create and copy required files.
    set(nacl_example_path ${PROJECT_SOURCE_DIR}/html/gl_basic_nacl)

    file(MAKE_DIRECTORY ${nacl_example_path})

    set_target_properties(gl_basic_nacl.nexe
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${nacl_example_path}
    )

    target_link_libraries(gl_basic_nacl.nexe
        ${waffle_libname}
        ${nacl_LDFLAGS}
        -lppapi_simple
        -lnacl_io
        )

    # Create .nmf file that contains JSON manifest for the .nexe required by NaCl
    # NOTE, this serves as example only and user might need to recreate nmf file
    # suitable for the used environment. Extra entry for libppapi_gles2.so is added
    # because we are not linking with it but require its presence during execution.
    # --no-arch-prefix is used because '-x' has no option to set architecture for
    # the extra entry.
    add_custom_command(
        OUTPUT gl_basic_nacl.nmf
        COMMAND ${nacl_root}/tools/create_nmf.py --no-arch-prefix -x libppapi_gles2.so:libppapi_gles2.so -L${CMAKE_LIBRARY_OUTPUT_DIRECTORY} ${nacl_example_path}/gl_basic_nacl.nexe -o ${nacl_example_path}/gl_basic_nacl.nmf
        DEPENDS gl_basic_nacl.nexe
        COMMENT "Create JSON manifest"
        VERBATIM
    )

    add_custom_target(gl_basic_create_json_manifest ALL
                      DEPENDS gl_basic_nacl.nmf)

    # install index.html that loads gl_basic_nacl.nmf
    file(INSTALL index.html DESTINATION ${nacl_example_path})

endif()

# ----------------------------------------------------------------------------
# Target: gl_basic (executable)
# ----------------------------------------------------------------------------

if(waffle_has_nacl)
    return()
endif()

add_executable(gl_basic gl_basic.c)
target_link_libraries(gl_basic ${waffle_libname} ${GETOPT_LIBRARIES})

if(waffle_on_mac)
    set_target_properties(gl_basic
        PROPERTIES
        COMPILE_FLAGS "-ObjC"
        )
endif()

=== include/CMakeLists.txt ===
configure_file(waffle-1/waffle_version.h.in
               ${CMAKE_CURRENT_SOURCE_DIR}/waffle-1/waffle_version.h
               @ONLY)

install(
    FILES
        waffle-1/waffle.h
        waffle-1/waffle_gbm.h
        waffle-1/waffle_glx.h
        waffle-1/waffle_version.h
        waffle-1/waffle_wayland.h
        waffle-1/waffle_x11_egl.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${waffle_libname}
    COMPONENT headers
    )

=== src/utils/CMakeLists.txt ===
# ----------------------------------------------------------------------------
# Target: wflinfo (executable)
# ----------------------------------------------------------------------------

if(waffle_has_nacl)
    return()
endif()

add_executable(wflinfo wflinfo.c)
target_link_libraries(wflinfo ${waffle_libname} ${GETOPT_LIBRARIES})

if(waffle_on_mac)
    set_target_properties(wflinfo
        PROPERTIES
        COMPILE_FLAGS "-ObjC"
        )
endif()

install(
    TARGETS wflinfo
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT utils
    )

=== src/waffle/CMakeLists.txt ===
--- 
+++ 
@@ -136,6 +136,25 @@
     )
 endif()
 
+macro(wayland_gen xml_file obj_name)
+    set(PROTO_FILE wl-${obj_name}-proto.c)
+    add_custom_command(
+        OUTPUT ${PROTO_FILE}
+        COMMAND ${WAYLAND_SCANNER} "private-code" ${xml_file} ${PROTO_FILE}
+    )
+    list(APPEND waffle_sources ${PROTO_FILE})
+endmacro()
+
+macro(wayland_gen_hdr xml_file obj_name)
+    set(HDR_FILE wl-${obj_name}-proto.h)
+    add_custom_target(wl_${obj_name}_proto_h ALL
+        COMMAND ${WAYLAND_SCANNER} "client-header" ${xml_file} ${HDR_FILE}
+    )
+    list(APPEND waffle_hdrdeps wl_${obj_name}_proto_h)
+    # Flip to enable -I builddir
+    set(CMAKE_INCLUDE_CURRENT_DIR ON)
+endmacro()
+
 if(waffle_has_wayland)
     list(APPEND waffle_sources
         wayland/wayland_display.c
@@ -143,6 +162,9 @@
         wayland/wayland_window.c
         wayland/wayland_wrapper.c
     )
+    wayland_gen(${wayland_core_xml} "core")
+    wayland_gen(${wayland_xdg_shell_xml} "xdg-shell")
+    wayland_gen_hdr(${wayland_xdg_shell_xml} "xdg-shell")
 endif()
 
 if(waffle_has_x11)
@@ -257,6 +279,12 @@
     VERSION ${waffle_soversion}.${waffle_minor_version}.${waffle_patch_version}
     )
 
+if(waffle_has_wayland)
+    foreach(_hdr ${waffle_hdrdeps})
+        add_dependencies(${waffle_libname} ${_hdr})
+    endforeach()
+endif()
+
 if(waffle_on_windows)
     set_target_properties(${waffle_libname}
         PROPERTIES

=== third_party/getopt/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_library(getopt_bundled STATIC EXCLUDE_FROM_ALL getopt_long.c)

install(
    FILES LICENSE
    DESTINATION "${CMAKE_INSTALL_DOCDIR}"
    RENAME LICENSE-getopt.txt
    COMPONENT coredocs
)

=== debian/changelog ===
waffle (1.7.0-2) unstable; urgency=medium

  * d/changelog: Release 1.7.0-2 to unstable

 -- Jordan Justen <jljusten@debian.org>  Wed, 18 Aug 2021 11:07:29 -0700

waffle (1.7.0-1) experimental; urgency=medium

  [ Jordan Justen ]
  * New upstream release
  * d/patches: Rebase to upstream v1.7.0
  * d/control: Update Standards-Version to 4.5.1
  * d/control: Set Rules-Requires-Root to no
  * d/control: Add wayland-protocols build dep
  * d/upstream/metadata: Set upstream metadata: Bug-Database, Bug-Submit

  [ Adrian Ratiu ]
  * d/rules: Fix xenabledenabled_egl -> x11_egl typo
  * d/control: Require cmake version >= 2.8.12

 -- Jordan Justen <jljusten@debian.org>  Thu, 25 Mar 2021 12:33:42 -0700

waffle (1.6.3-3) unstable; urgency=medium

  * debian: Run wrap-and-sort
  * d/control: libwaffle-dev depends on egl, gbm, gl, wayland and x11-xcb.
    Closes: #987940, #987879

 -- Jordan Justen <jljusten@debian.org>  Mon, 03 May 2021 09:44:42 -0700

waffle (1.6.3-2) unstable; urgency=medium

  [ Jordan Justen ]
  * d/control: Update Standards-Version to 4.5.1
  * d/control: Set Rules-Requires-Root to no
  * d/upstream/metadata: Set upstream metadata: Bug-Database, Bug-Submit
  * d/upstream/metadata: Add repository information for lintian upstream-metadata-missing-repository
  * d/control: Update project homepage url for move to freedesktop.org

  [ Adrian Ratiu ]
  * d/rules: Fix xenabledenabled_egl -> x11_egl typo

  [ Adrian Bunk ]
  * d/control: libwaffle-dev: Depend on libudev-dev. (Closes: #986517)

 -- Jordan Justen <jljusten@debian.org>  Sat, 24 Apr 2021 02:02:31 -0700

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,15 @@
 Section: libs
 Maintainer: Jordan Justen <jljusten@debian.org>
 Build-Depends: bash-completion,
-               cmake,
+               cmake (>= 2.8.12),
                debhelper-compat (= 13),
                dh-exec,
                docbook-xml,
                docbook-xsl,
                libegl1-mesa-dev | libegl-dev,
+               libgbm-dev,
                libgl1-mesa-dev | libgl-dev,
                libglu1-mesa-dev | libglu-dev,
-               libgbm-dev,
                libudev-dev,
                libwayland-dev,
                libx11-xcb-dev,
@@ -19,16 +19,18 @@
                pkg-config,
                python3,
                python3-setuptools,
+               wayland-protocols,
                xsltproc
-Standards-Version: 4.5.0
-Homepage: http://www.waffle-gl.org
+Standards-Version: 4.5.1
+Rules-Requires-Root: no
+Homepage: https://waffle.freedesktop.org/
 Vcs-Git: https://salsa.debian.org/xorg-team/lib/waffle.git
 Vcs-Browser: https://salsa.debian.org/xorg-team/lib/waffle
 
 Package: libwaffle-1-0
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Description: Waffle library (binaries)
  A library for selecting an OpenGL API and window system at runtime
@@ -39,7 +41,14 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libwaffle-1-0 (= ${binary:Version}), ${misc:Depends}
+Depends: libegl-dev,
+         libgbm-dev,
+         libgl-dev,
+         libudev-dev,
+         libwaffle-1-0 (= ${binary:Version}),
+         libwayland-dev,
+         libx11-xcb-dev,
+         ${misc:Depends}
 Suggests: libwaffle-doc
 Description: Waffle library (development files)
  A library for selecting an OpenGL API and window system at runtime
@@ -60,7 +69,9 @@
 Package: waffle-utils
 Architecture: any
 Section: utils
-Depends: libwaffle-1-0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: libwaffle-1-0 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: Waffle library (utilities)
  A library for selecting an OpenGL API and window system at runtime
  .

## waffle 1.7.2

=== src/waffle/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,14 @@
 add_definitions(
     -DWAFFLE_API_VERSION=${waffle_api_version}
     -DWAFFLE_API_EXPERIMENTAL
+    ${egl_CFLAGS}
+    ${gbm_CFLAGS}
+    ${gl_CFLAGS}
+    ${GLEXT_CFLAGS}
+    ${libudev_CFLAGS}
+    ${wayland-client_CFLAGS}
+    ${wayland-egl_CFLAGS}
+    ${x11-xcb_CFLAGS}
     )
 
 include_directories(
@@ -197,7 +205,6 @@
         wgl/wgl_context.c
         wgl/wgl_display.c
         wgl/wgl_dl.c
-        wgl/wgl_error.c
         wgl/wgl_platform.c
         wgl/wgl_window.c
         )

=== debian/changelog ===
waffle (1.7.2-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints. + libwaffle-doc: Add Multi-Arch: foreign.
  * Remove constraints unnecessary since buster (oldstable)

  [ Jordan Justen ]
  * New upstream release
  * d/changelog: Start 1.7.2-1 changelog
  * d/control: Update Standards-Version to 4.6.2
  * d/source/lintian-overrides: Override patch-not-forwarded-upstream
  * d/libwaffle-dev: Drop cmake files from dev package
  * d/control: Drop cmake build dependency
  * d/waffle-utils: Add zsh completion
  * d/control: Drop deprecated libgl1-mesa-dev dependency

 -- Jordan Justen <jljusten@debian.org>  Fri, 10 Mar 2023 11:21:40 -0800

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,13 @@
 Section: libs
 Maintainer: Jordan Justen <jljusten@debian.org>
 Build-Depends: bash-completion,
-               cmake (>= 2.8.12),
                debhelper-compat (= 13),
                dh-exec,
                docbook-xml,
                docbook-xsl,
                libegl1-mesa-dev | libegl-dev,
                libgbm-dev,
-               libgl1-mesa-dev | libgl-dev,
+               libgl-dev,
                libglu1-mesa-dev | libglu-dev,
                libudev-dev,
                libwayland-dev,
@@ -21,7 +20,7 @@
                python3-setuptools,
                wayland-protocols,
                xsltproc
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://waffle.freedesktop.org/
 Vcs-Git: https://salsa.debian.org/xorg-team/lib/waffle.git
@@ -60,6 +59,7 @@
 Architecture: all
 Section: doc
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: Waffle library (documentation)
  A library for selecting an OpenGL API and window system at runtime
  .
